﻿using System;
using System.Diagnostics;
using System.IO;

namespace PersonTrace
{
    /// <summary>
    /// This example is very simple, to simple in fact.
    /// Tracing is more useful with long-running applications like servers, etc.
    /// Anyway, the example show the very basics of tracing
    /// </summary>
    class Program
    {
        static void Main()
        {
            SetUpTracing();

            Person p1 = new Person();
            p1.Name = "Adam";
        }

        private static void SetUpTracing()
        {
            Trace.AutoFlush = true; // flush at every write

            Trace.Listeners.Add(new ConsoleTraceListener());
            FileStream fs = new FileStream("c:/temp/log.txt", FileMode.Append);
            TextWriterTraceListener textWriterTraceListener = new TextWriterTraceListener(fs);
           
            Trace.Listeners.Add(textWriterTraceListener);

            //Trace.Listeners.Add(new XmlWriterTraceListener("c:/temp/log_xml.txt"));

            //Trace.Listeners.Add(new MySmsTraceListener("12345678"));

            //ShowTraceListeners();
        }

        private static void ShowTraceListeners()
        {
            TraceListenerCollection listeners = Trace.Listeners;
            foreach (object listener in listeners)
            {
                Console.WriteLine(listener);
            }
        }
    }

    class MySmsTraceListener : TraceListener
    {
        public string Phone { get; set; }

        public MySmsTraceListener(string phone)
        {
            Phone = phone;
        }

        public override void Write(string message)
        {
            // Send an SMS to the systems administrator
            Console.Write("SMS {0}: {1} ", Phone, message);
        }

        public override void WriteLine(string message)
        {
            // Send an SMS to the systems administrator
            Console.WriteLine("SMS {0}: {1} ", Phone, message);
        }
       
        public override string ToString()
        {
            return "SMS listener, sending SMS to " + Phone;
        }
    }
}
